#ifndef  _ADDEF_
#define  _ADDEF_

#define NUMMODTYPES 6
/* 
 * This was 5. I have changed it to 6, since there are 6 types:
 * CBLK, SWCH, OPAMP, CHAN, INMOD, OUTMOD
 * There are a lot of NUMMODTYPES+1 everywhere, I don't know why this
 * was set to 5 instead of 6.
 * -hcc
 */
#define OPAMP 1
#define SWCH 2
#define CBLK 3
#define INMOD 4
#define OUTMOD 5

#define MAXNUMPHI 10

#define MAXNUMCH 10
#define MAXNUMDIR 5
#define TOP 1
#define BOTTOM 2
#define RIGHT 3
#define LEFT 4

#define CLKCH 3

#define INPUT 1
#define OUTPUT 2
#define INOUT 3

#define GROUND 1
#define IN 2
#define OUT 3
#define CONT 4
#define SWITCHED 5
#define CLOCK 6

#define NO 1
#define YES 2

#define EXACT 1
#define APPROX 2

#define OPEN 1
#define CLOSED 2

#define ON 1
#define OFF 0

#define MAXNUMIN 3
#define PLUS 1
#define MINUS 2

#define HORIZ 1
#define VERT 2

#define FAILURE 1
#define SUCCESS 2

#define SWIN   1
#define SWOUT2 2
#define SWOUT3 3

#define FLR 1
#define RND 2
#define CEIL 3

#define MAXNUMROW 101
#define MAXNUMCOL 101

#define MAXINT 0X7FFFFFFF
#define MAXREAL 1.e80

#define NOT_ASSIGNED 0

/*
 * Various String Sizes
 */

#define TERMINALNAME_SIZE 110
#define NETNAME_SIZE 40 
#define PROPERTYNAME_SIZE 8

/*
 * File declarations
 */

#define FILENAME_SIZE 255
#define UNIX_COMMAND_SIZE 1024

#define CALLOC(a, n, b) a = (b *) calloc(n, sizeof(b))

/*
 * CALLOC_ERRCHK: 
 * CALLOC which checks for NULL pointer return
 * If an error is detected, errRaise is used to flag the error.
 * C_FILE_NAME a definition that has to be set up in the calling c file. 
 * Also "errtrap.h" must be incuded.
 * a = pointer
 * b = type
 * n = number of elements
 * -hcc
 */ 
#define CALLOC_ERRCHK(a, n, b) \
	if ( ( a = (b *) calloc(n, sizeof(b)) ) == NULL ) \
           errRaise (C_FILE_NAME,0,"calloc error for a")

#define MALLOC_ERRCHK(y, type, size) \
	if ( ( y = (type *) calloc (1, (unsigned) (size)) ) == NULL ) \
	   errRaise (C_FILE_NAME,0,"calloc error for y")

#define max(A, B) ((A) > (B) ? (A) : (B))
#define min(A, B) ((A) < (B) ? (A) : (B))

#endif
