/* find xtranslation of modules , and x coordinate of terminals for adore2 */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* Last Change: 7/19/87 */

#include "ADglobals.h"
#include "TEKtech.h"
#include <stdio.h>

#define  permFindX(m,z)   ((m)->transform == NO) ? \
                           ((m)->xtrans + (m)->xsep + z) : \
                           ((m)->xtrans + (m)->xsep + (m)->xdim - z)

PERMfindXcrd( terminal )
struct _terminal *terminal;
{
    int xcoord;

    xcoord = permFindX( terminal->module, terminal->xcoord );
    return xcoord;
}

PERMfindXeqt( eqterm )
struct _eqterm *eqterm;
{
    int xcoord;

    xcoord = permFindX( eqterm->module, eqterm->xcoord );
    return xcoord;
}


PERMfindXtrans( modtype )
int modtype; /* SWCH OPAMP or CBLK */
{
    struct _module *tmpmod, *prevmod;


    tmpmod  = modlist[modtype];
    prevmod = modlist[INMOD];
    for ( ; tmpmod != NULL; tmpmod = tmpmod->next ) {
        tmpmod->xtrans = prevmod->xtrans + prevmod->xsep + prevmod->xdim;
        prevmod = tmpmod;
    }

    if ( modtype == CBLK ) {
        modlist[OUTMOD]->xtrans= prevmod->xtrans+ prevmod->xsep + prevmod->xdim;
        modlist[OUTMOD]->xdim = 0;
        modlist[OUTMOD]->xsep = max(0, chipxdim -  modlist[OUTMOD]->xtrans);
    }
}

PERMfindXsep()
/* find x separation of capacitor blocks */
{
    struct _module *tmpmod;

    tmpmod = modlist[CBLK];
    tmpmod->xsep = minoverhang + max(polywidth, metwidth);
    tmpmod = tmpmod->next;
    for ( ;tmpmod != NULL; tmpmod = tmpmod->next ) {
        tmpmod->xsep = blkxsep;
    }
}
