/* generate the input for channel router, used by adore2 */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* Last Change: 7/23/87 */

/*
 * Modifications to Adore
 * Henry Chang (henryc@ic.Berkeley.EDU)
 * Fall, 1990
 */

#define C_FILE_NAME "ROUTchrInput.c"

#include "ADglobals.h"
#include "ROUTglobals.h"

#include <stdio.h>

ROUTchrInput( channel, tmp_dir )
struct _channel *channel;
char *tmp_dir;
{
	char filename[FILENAME_SIZE];
	FILE *fpchin, *fopen();
	struct _terminal *tmpterm;

	sprintf (filename, "%s/%s", tmp_dir, CH_IN_FILE);
	fpchin = fopen(filename,"w");

	fprintf(fpchin,"channeldef\n");

	fprintf(fpchin,"rectagoncorners %d\n", 4);
	fprintf(fpchin,"%d %d\n", channel->lowchx, channel->lowchy);
	fprintf(fpchin,"%d %d\n", channel->hichx, channel->lowchy); 
	fprintf(fpchin,"%d %d\n", channel->hichx, channel->hichy);
	fprintf(fpchin,"%d %d\n", channel->lowchx, channel->hichy);

	fprintf(fpchin,"number_of_nets %d\n", channel->numnets);
	fprintf(fpchin,"number_of_pins %d\n", 
						   channel->numterms[TOP] + channel->numterms[BOTTOM]);

	tmpterm = channel->tlist[BOTTOM];
	for ( ; tmpterm != NULL; tmpterm = tmpterm->nxtcht ) {
		fprintf(fpchin,"%d %d %d %d\n",tmpterm->netptr->number,
				tmpterm->chxcoord,tmpterm->chycoord,tmpterm->chrlayer);
	}

	tmpterm = channel->tlist[TOP];
	for ( ; tmpterm != NULL; tmpterm = tmpterm->nxtcht ) {
		fprintf(fpchin,"%d %d %d %d\n",tmpterm->netptr->number,
				tmpterm->chxcoord,tmpterm->chycoord,tmpterm->chrlayer);
	}

	if ( (tmpterm = channel->tlist[LEFT]) != NULL ) {
		fprintf(fpchin,"left_list %d\n", channel->numterms[LEFT]);
		for ( ; tmpterm != NULL; tmpterm = tmpterm->nxtcht ) {
			fprintf(fpchin,"%d\n",tmpterm->netptr->number);
		}
	}

	if ( (tmpterm = channel->tlist[RIGHT]) != NULL ) {
		fprintf(fpchin,"right_list %d\n",channel->numterms[RIGHT]);
		for ( ; tmpterm != NULL; tmpterm = tmpterm->nxtcht ) {
			fprintf(fpchin,"%d\n",tmpterm->netptr->number);
		}
	}

	fprintf(fpchin,".end\n");
	fclose( fpchin );
}
