/* sort the terminals of each array, used by adore2 */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* LastChange : 7/23/87 */

#include "ADglobals.h"
#include <stdio.h>

/* make terminal lists */
ROUTmkTlist()
{
  int counter;
  struct _module *tmpmod;
  struct _terminal *tmpterm;

  for ( counter = 1; counter <= 5; counter++ ) {
    switch ( counter ) {
    case 1 :
      tmpmod = modlist[OPAMP]; 
      break;
    case 2 :
      tmpmod = modlist[CBLK]; 
      break;
    case 3 :
      tmpmod = modlist[SWCH]; 
      break;
    case 4 :
      tmpmod = modlist[INMOD];
      break;
    case 5 :
      tmpmod = modlist[OUTMOD];
      break;
    }
    for ( ; tmpmod != NULL; tmpmod = tmpmod->next ) {
      tmpterm = tmpmod->terminals;
      for ( ; tmpterm != NULL; tmpterm = tmpterm->next ) {
	ROUTsortTerm(tmpterm);
      }
    }
  }
}

/* find which list the terminal belongs to and add it to that list */
ROUTsortTerm( terminal )
struct _terminal *terminal;
{
  int listtype; /* TOP, RIGHT, BOTTOM, LEFT */

  if ( terminal->netptr->type == GROUND ) {
    return;
  }

  if(terminal->channel == NULL) {
    fprintf(stderr,"ROUTsortTerm;1: internal error\n");
    return;   /* Added by Enrico 10/22/1990 */
  }

  if ( terminal->module->type == INMOD ) {
    listtype = LEFT;
  }
  else if ( terminal->module->type == OUTMOD ) {
    listtype = RIGHT;
  }
  else if ( terminal->channel->name == BOTTOM ) {
    if ( terminal->module->row == 1 ) {
      listtype = BOTTOM;
    }
    else if ( terminal->module->row == 2 ) {
      listtype = TOP;
    }
    else {
      fprintf(stderr,"ROUTsortTerm;1: internal error\n");
      exit(-1);
    }
  }
  else if ( terminal->channel->name == TOP ) {
    if ( terminal->netptr->type == CLOCK ) {
      /* It will be checked later */
    }
    else if ( terminal->module->row == 2 ) {
      listtype = BOTTOM;
    }
    else if ( terminal->module->row == 3 ) {
      listtype = TOP;
    }
    else {
      fprintf(stderr,"ROUTsortTerm;2: internal error\n");
      exit( -1 );
    }
  }
  else if ( terminal->channel->name == CLKCH ) {
    if ( terminal->module->row == 3 ) {
      listtype = BOTTOM;
    }
    else {
      fprintf(stderr,"ROUTsortTerm;3: internal error\n");
      exit( -1 );
    }
  }
  else {
    fprintf(stderr,"ROUTsortTerm;4: internal error\n");
    exit( -1 );
  }
  
  ROUTaddTlist( terminal->channel, listtype , terminal );
}

/* add a terminal to a previosly sorted list of terminals */
/* increment the corresponding number of terminals for that channel */
ROUTaddTlist( channel, listtype, terminal )
struct _channel *channel; /* TOP or BOT */
int listtype; /* TOP, BOTTOM, RIGHT, LEFT */
struct _terminal *terminal;
{
  int termxcrd, PERMfindXcrd();
  struct _terminal *tlist;
  struct _terminal *curterm, *prevterm;

  channel->numterms[listtype]++;

  termxcrd = PERMfindXcrd(terminal);
  if ( (tlist = channel->tlist[listtype]) == NULL 
      || termxcrd <= PERMfindXcrd(tlist) ) {
    terminal->nxtcht = tlist;
    channel->tlist[listtype] = terminal;
    return;
  }
		
  for (prevterm = tlist ; ; prevterm = prevterm->nxtcht) {
    if ( (curterm = prevterm->nxtcht) == NULL ||
	termxcrd <= PERMfindXcrd(curterm) ) {
      prevterm->nxtcht = terminal;
      terminal->nxtcht = curterm;
      return;
    }
  }
}
